; vim: ft=fasm :
; RETRO-NG, Release 6.20
; Forth Primitives
;---------------------------------------------------------------------


;---------------------------------------------------------------------
var 'h', h, h0
var 'd', d, d0
var 'base', base, 10
var 'source', source, 0
tin dd 0
tp  dd tib
;---------------------------------------------------------------------


;---------------------------------------------------------------------
code 'sp@', sp_fetch
	upsh esi
next

code 'bytes', bytes
	upop ecx
.a:	push ecx
	embed 'c,'
	pop ecx
	loop bytes.a
next

code 'execute', execute
	mov ebx, eax
	drop
	call ebx
next

; ( source dest count -- )
code 'cmove', $cmove
	mov ecx,eax
	drop
	mov edi,eax
	drop
	push esi
	mov esi,eax
.a:	mov edx, [esi] 
	mov [edi], edx
	inc edi
	inc esi
	loop .a
	pop esi
	drop
next

code '@', fetch
	mov eax,[eax]
next

code '+',plus
	add eax,[esi] ; +
	add esi,4
next

code '-', subtract
	sub [esi], eax
	drop
next

code '*', multiply
	mul dword [esi]
	add esi, 4
next

code '/', divide
	upop ebx
	xor edx, edx
	idiv ebx
next
	
	
code '.', print
	push edx
	push edi
	mov edi,esi	;edi = buffer (in stack space)
	sub edi,4
	or eax,eax	;Negative?
	jns .a
	neg eax
	upsh '-'
	call emit
.a:			;Convert
	xor edx,edx
	div dword [base]
	add dl,'0'
	cmp dl,'9'
	jbe .b
	add dl,7+32
.b:	dec edi
	mov [edi],dl
	or eax,eax
	jnz .a
	mov eax,edi	;Print
	upsh esi
	sub eax,edi	;# of digits
	call type
	pop edi
	pop edx
	upsh ' '	; And add one space after
	call emit	; the number
next

s_dest dd 0
code 's', s
	upop [s_dest]
	mov [tp],dword tib
.a:	call key
	cmp al,10
	je .done
	cmp al,13
	je .done	
	xchg edi,[tp]
	stosb
	xchg [tp],edi
	call emit
	jmp .a
.done:	push ecx	;move string to a safer place...
	push edi
	mov edi,[s_dest]
	mov eax,edi ;push addr
	dup
	push esi
	mov ecx,[tp]
	mov esi,tib
	sub ecx,esi
	mov eax,ecx	;push length
	rep movsb
	pop esi
	pop edi
	pop ecx
	call cr
next

code '!', store
	upop edx
	mov [edx],eax
	drop
next

code 'c!', cstore
	upop edx
	mov [edx], al
	drop
next

code 'c@', cfetch
	upop edx
	dup
	xor eax,eax
	mov al, [edx]
next

code 'type',type
	push ebx
	push ecx
	upop ecx
	upop ebx
	or ecx,ecx	; Is the count zero?
	jz .done	; If so, we can exit
.a: 	push ecx	; store the count
	dup		; Duplicate it
	xor eax,eax 	; Filter out junk bits
	mov al,[ebx]	; Obtain the byte to show
	inc ebx		; increment to the next byte
	call emit	; Show the character
	pop ecx		; Restore the count
	loop .a		; Loop, decrementing the count
.done:	pop ecx
	pop ebx
next

code 'word',$word
	mov edi,[tin]	; Pointer into TIB
	mov ecx,[tp]
	sub ecx,edi
	inc ecx
	repe scasb
	dec edi
	inc ecx
	dup
	mov [esi],edi	;a
	repne scasb
	mov eax,edi
	dec eax
	sub eax,[esi]	;n
	mov [tin],edi
next


;---------------------------------------------------------------------
; Debugger Oriented Words
;---------------------------------------------------------------------
code 'words',words
	push ebx
	mov ebx, [last]
.a:	mov ebx,[ebx]
	or ebx,ebx
	jz .end
	dup
	lea eax,[ebx+8]
	dup
	movzx eax,byte [eax]
	inc dword [esi]
	call type
	upsh 32
	call emit
	jmp .a
.end:	pop ebx
next

code 'last', dbg_last
   upsh last
next

code '<<', l_shift
  upop ecx
  sal eax,cl
next

code '>>', r_shift
  upop ecx
  sar eax,cl
next

code 'or', f_or
  upop ebx
  or eax, ebx
next

code 'depth', depth
    upsh sp0
    upsh esi
    call subtract
    upsh 4
    call divide
    upsh 1
    call subtract
    cmp eax, 0
    jl .a
    jmp .b
.a: mov eax, 0
    mov esi, sp0
    upsh stack_message
    upsh 15
    call type
.b:
next
stack_message db "stack underflow"
	
code '.s', show_stack
	call depth
	mov eax,sp0
	mov ecx,eax
	sub ecx,esi
	jz .done
	shr ecx,2
.a:	sub eax, 4
	dup
	mov eax,[eax]
	call print
	loop .a
.done:	drop
next

code 'reset', reset
	mov esi, sp0
next
	
;---------------------------------------------------------------------
; ( Allocate the dictionary space )
flast dd forth_link         ; ( Forth words )
mlast dd macro_link         ; ( Macro [inline] words )
last  dd flast              ; ( Pointer to last word )
;---------------------------------------------------------------------
